#!/usr/bin/perl -w

print STDOUT "type genbank file\n";
$infile=<STDIN>;
chomp($infile);

open(FIN, "< $infile") or die;
while($line=<FIN>){
	chomp($line);
	if($line=~/LOCUS/){
		
		$acc="X";
		$definition="X";
		$organism="X";
		$strain="X";
		$isolate="X";
		$country="X";
		$date="X";
		$pubmedid="X";
		$isolation_source="X";
		$protein_id="X";
		$complete_genome_cds="X";
		$cds_coords="X";
		
		$serotype="X";
		$taxonomy="X";
		$taxonomy2="X";
		@tmp_array=();
		$tmp_num=0;
		$note="X";
	}
	if($line=~/DEFINITION/){
		while(!(($line=~/ACCESSION/) || ($line=~/VERSION/) || ($line=~/SOURCE/))){
			$definition=$definition.$line;
			$line=<FIN>;
			chomp($line);
		}
		if(($definition=~/complete genome/) || ($definition=~/complete cds/)){
			$complete_genome_cds="COMPLETE";
		}
	}
	if($line=~/ACCESSION/){
		$line=~/ACCESSION\s+(\S+)/;
		$acc=$1;
	}

	if($line=~/ORGANISM/){
		while(!(($line=~/REFERENCE/) || ($line=~/AUTHORS/) || ($line=~/TITLE/) || ($line=~/AUTHORS/))){
			$taxonomy=$taxonomy.$line;
			$line=<FIN>;
			chomp($line);
		}
		@tmp_array=split(/;/, $taxonomy);
		$tmp_num=@tmp_array;
		$taxonomy2=$tmp_array[$tmp_num - 1];
	}

	if($line=~/\/organism=\"/){
		$line=~/\/organism=(.+)/;
		$organism=$1;
	}
	if($line=~/\/isolate=\"/){
		$line=~/\/isolate=(.+)/;
		$isolate=$1;
	}
	if($line=~/\/strain=\"/){
		$line=~/\/strain=(.+)/;
		$strain=$1;
	}
	if($line=~/\/serotype=\"/){
		$line=~/\/serotype=(.+)/;
		$serotype=$1;
	}	
	if($line=~/\/note=\"/){
		$line=~/\/note=(.+)/;
		$note=$1;
	}
	if($line=~/\/country=\"/){
		$line=~/\/country=(.+)/;
		$country=$1;
	}
	if($line=~/\/collection_date=\"/){
		$line=~/\/collection_date=(.+)/;
		$date=$1;
	}
	if($line=~/\/isolation_source=\"/){
		$line=~/\/isolation_source=(.+)/;
		$isolation_source=$1;
	}
	if($line=~/PUBMED\s+\d+/){
		$line=~/PUBMED\s+(\d+)/;
		$pubmedid=$1;
	}
	if($line=~/\/protein_id=\"/){
		$line=~/\/protein_id=\"(\S+)\"/;
		$protein_id=$1;
	}
	if($line=~/^\s+CDS\s+/){
		$line=~/^\s+CDS\s+(\S+)/;
		$cds_coords=$1;
	}

	$hash{$acc}[0]=$organism;
	$hash{$acc}[1]=$strain;
	$hash{$acc}[2]=$isolate;
	$hash{$acc}[3]=$serotype;
	$hash{$acc}[4]=$note;
	$hash{$acc}[5]=$taxonomy2;
	$hash{$acc}[6]=$country;
	$hash{$acc}[7]=$date;
	$hash{$acc}[8]=$isolation_source;
	$hash{$acc}[9]=$pubmedid;
	$hash{$acc}[10]=$protein_id;
	$hash{$acc}[11]=$definition;
	$hash{$acc}[12]=$complete_genome_cds;
	$hash{$acc}[13]=$cds_coords;
}
close(FIN);

@keys_array= sort keys %hash;

open(FOUT, "> results_from_genbank");
foreach $key (@keys_array){
	print FOUT "$key";
	for($i=0;$i<14;$i++){
		print FOUT "\t$hash{$key}[$i]";
	}
	print FOUT "\n";
}
close(FOUT);
